Summary: Secure Sockets Layer communications libs & utils
%define major 0
%define minor 9.6
%define m2crypto_version 0.06-snap2
%define swig_version 1.1p5

Name: openssl
Version: 0.9.6
Release: 17tr
Source: http://www.openssl.org/source/openssl-%{version}.tar.gz
Source1: http://download.sourceforge.net/swig/swig%{swig_version}.tar.gz
Source2: http://mars.post1.com/home/ngps/m2/m2crypto-%{m2crypto_version}.tar.gz
Patch0: openssl-rh6.patch
Patch1: openssl-0.9.6-rehash.patch
Patch2: openssl-0.9.6-configure.patch
Patch3: openssl-tr.patch 
Patch4: openssl-0.9.6-makefile.patch
Patch10: openssl-0.9.6-bleichenbacher.patch
Patch11: openssl-crt.patch
Patch12: openssl-setugid.patch
Patch13: openssl-zero-premaster.patch
Patch14: openssl-0.9.6-prng.patch
Patch15: openssl-CAN-2002-065N-asn1_lib.patch
Patch16: openssl-CAN-2002-065N-CHANGES.patch
Patch17: openssl-CAN-2002-065N-conf_def.patch
Patch18: openssl-CAN-2002-065N-cryptlib.h.patch
Patch19: openssl-CAN-2002-065N-cryptlib.patch
Patch20: openssl-CAN-2002-065N-obj_dat.patch
Patch21: openssl-CAN-2002-065N-s2_clnt.patch
Patch22: openssl-CAN-2002-065N-s2_lib.patch
Patch23: openssl-CAN-2002-065N-s2_srvr.patch
Patch24: openssl-CAN-2002-065N-s3_clnt.patch
Patch25: openssl-CAN-2002-065N-s3_srvr.patch
Patch26: openssl-CAN-2002-065N-ssl_asn1.patch
Patch27: openssl-CAN-2002-065N-ssl_err.c.patch
Patch28: openssl-CAN-2002-065N-ssl.h.patch
Patch29: openssl-CAN-2002-065N-ssl_sess.patch
Patch30: openssl-0.9.6-engarde-s3_pkt.patch
Patch31: openssl-0.9.6-mem.patch
Patch32: openssl-0.9.6-blind.patch
Patch33: openssl-KPR.patch
Patch34: openssl-11470.patch
Patch35: openssl-0.9.6-nodie.patch
Patch36: openssl-0.9.7c-CAN-2004-0079.patch
Patch37: openssl-0.9.7c-CAN-2004-0081.patch

License: Dual License (OpenSSL and SSLeay) bsdstyle Open Source
Group: Environment/Cryptography
Provides: SSL
URL: http://www.openssl.org
BuildRoot: /var/tmp/openssl-%{version}-root

%description
A C library that provides various crytographic algorithms and protocols,
including DES, RC4, RSA, and SSL. Includes shared libraries.

%package support
Summary: Secure Sockets Layer communications support utilities.
Group: Environment/Cryptography
Requires: openssl
%description support
A C library that provides various crytographic algorithms and protocols,
including DES, RC4, RSA, and SSL. Includes support utilities.

%package devel
Summary: Secure Sockets Layer communications static libs & headers.
Group: Libraries/Development
Requires: openssl
%description devel
A C library that provides various crytographic algorithms and protocols,
including DES, RC4, RSA, and SSL. Includes static libraries and headers.

%package python
Summary: Support for using OpenSSL in python scripts.
Group: Libraries/Runtime
Requires: python
%description python
This package allows you to call OpenSSL functions from python scripts.

%prep
%setup -q
#%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
pushd crypto/rand
%patch14 -p0
popd
%patch15 -p0
%patch16 -p0
%patch17 -p0
%patch18 -p0
%patch19 -p0
%patch20 -p0
%patch21 -p0
%patch22 -p0
%patch23 -p0
%patch24 -p0
%patch25 -p0
%patch26 -p0
%patch28 -p0
%patch29 -p0
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p0
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch37 -p1

%setup -T -D -n openssl-%{version}
perl util/perlpath.pl /usr/bin

# Extract what we need for building extensions.
gzip -dc %{SOURCE1} | tar xf -
gzip -dc %{SOURCE2} | tar xf -
pushd m2crypto-%{m2crypto_version}
    for file in demo/evp_ciph_test.py demo/bio_ciph_test.py swig/_evp.i ; do
	grep -v idea_ ${file} > ${file}.tmp
	grep -v rc5_  ${file}.tmp > ${file}
    done
popd



%build
PATH=${PATH}:${PWD}/bin
TOPDIR=${PWD}
NEED_PERL_LINK=0
if [ ! -f /usr/local/bin/perl ]; then
  NEED_PERL_LINK=1
  ln -s /usr/bin/perl /usr/local/bin/perl
fi
export LD_LIBRARY_PATH=`pwd`
RPM_OPT_FLAGS="$RPM_OPT_FLAGS"
export RPM_OPT_FLAGS
./config --prefix=/usr --openssldir=/etc/ssl shared threads
make
make linux-shared
make rehash
make test

## Build shared libraries.
majorver=`echo %{version} | cut -f1 -d.`
for shlib in crypto ssl ; do
	pushd $shlib
		objs=`ar t ../lib${shlib}.a | xargs -n 1 find . -name`
		%{__cc} -shared -o ../lib${shlib}.so.%{version} \
			-Wl,-soname=lib${shlib}.so.${majorver} $objs && \
		ln -sf lib${shlib}.so.%{version} ../lib${shlib}.so
	popd
done

# Build a copy of swig with which to build the extensions.
pushd SWIG%{swig_version}
autoconf
CFLAGS="%{optflags}" \
CCFLAGS="%{optflags}" \
FFLAGS="%{optflags}" \
./configure --prefix=${TOPDIR}
make all install
popd

# Build the python extensions.
pushd m2crypto-%{m2crypto_version}/swig
export PATH=`pwd`/../../bin/:$PATH
make \
	INCLUDE="-I. -I../../include/openssl" \
	LIBS="-L${TOPDIR} -lssl -lcrypto -lc" \
	PYINCLUDE="-DHAVE_CONFIG_H -I/usr/include/python1.5 -I/usr/lib/python1.5/config" \
	PYLIB="/usr/lib/python1.5/config" \
	-f Makefile.py1
#cd ../doc
#sh -x go
popd

	
%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/share/man
mkdir -p $RPM_BUILD_ROOT/etc/ssl
mkdir -p $RPM_BUILD_ROOT/usr/bin
mkdir -p $RPM_BUILD_ROOT/usr/include/openssl
mkdir -p $RPM_BUILD_ROOT/usr/lib
make INSTALL_PREFIX=$RPM_BUILD_ROOT install
mv $RPM_BUILD_ROOT/etc/ssl/misc/* $RPM_BUILD_ROOT/usr/bin
mv $RPM_BUILD_ROOT/usr/share/man/man1/passwd.1 $RPM_BUILD_ROOT/usr/share/man/man1/passwd.3
rm -rf $RPM_BUILD_ROOT/etc/ssl/misc
rm -rf $RPM_BUILD_ROOT/etc/ssl/lib

install -m644 libRSAglue.a $RPM_BUILD_ROOT/usr/lib
install -m644 libcrypto.a $RPM_BUILD_ROOT/usr/lib
install -m644 libssl.a $RPM_BUILD_ROOT/usr/lib
install -m644 rsaref/rsaref.h $RPM_BUILD_ROOT/usr/include/openssl

strip $RPM_BUILD_ROOT/usr/bin/openssl

# Install the python extensions.
pushd m2crypto-%{m2crypto_version}/M2Crypto
mkdir -p $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/M2Crypto/{PGP,SSL}
find -name "*.py" | xargs -i install -m644 '{}' $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/M2Crypto/'{}'
find -name "*.so" | xargs -i install -m755 '{}' $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/M2Crypto/'{}'
python -c "import compileall; compileall.compile_dir('"$RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/M2Crypto"', 3, '/usr/lib/python1.5/site-packages/M2Crypto')"
popd


%clean
rm -rf $RPM_BUILD_ROOT
if [ "$NEED_PERL_LINK" = "1" ]; then
  rm /usr/local/bin/perl
fi

%files
%defattr(-,root,root)
%doc CHANGES
%doc CHANGES.SSLeay
%doc INSTALL
%doc LICENSE
%doc README
%doc NEWS
%doc doc/*
/usr/bin/openssl
/usr/lib/libcrypto.so
/usr/lib/libcrypto.so.0
/usr/lib/libcrypto.so.%{major}.%{minor}
/usr/lib/libssl.so
/usr/lib/libssl.so.0
/usr/lib/libssl.so.%{major}.%{minor}
%config(noreplace) %verify(not md5 size mtime) /etc/ssl/openssl.cnf
%dir /etc/ssl
%dir /etc/ssl/private
%dir /etc/ssl/certs
/usr/share/man/*/*

%files support
/usr/bin/CA.pl
/usr/bin/CA.sh
/usr/bin/c_hash
/usr/bin/c_info
/usr/bin/c_issuer
/usr/bin/c_name
#/usr/bin/der_chop
/usr/bin/c_rehash
		
%files devel
/usr/lib/libcrypto.a
/usr/lib/libssl.a
/usr/include/openssl
/usr/lib/libRSAglue.a
 
%files python
%defattr(-,root,root)
%doc m2crypto-%{m2crypto_version}/{BUGS,CHANGES,LIC*,README,TODO}
#%doc m2crypto-%{m2crypto_version}/doc/{README,*.html}
%{_libdir}/python1.5/site-packages/M2Crypto


%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%changelog
* Tue Sep 28 2004 Oystein Viggen <oysteivi at trustix dot com> 0.9.6-18tr
- Remove der_chop (has a security hole, and according to openssl developers
  shouldn't be used anyway).

* Tue Mar 16 2004 Oystein Viggen <oysteivi at trustix dot com> 0.9.6-17tr
- Patch two DoS holes: CAN-2004-0079, CAN-2004-0081

* Fri Oct  3 2003 Erlend Midttun <erlendbm@trustix.com> 0.9.6-16tr
- Prevent the use of die().

* Tue Sep 30 2003 Erlend Midttun <erlendbm@trustix.com> 0.9.6-15tr
- Added patchset 11470.

* Thu Mar 20 2003 Erlend Midttun <erlendbm@trustix.com> 0.9.6-14tr
- Added patch to prevent the Klima-Pokorny-Rosa attack.

* Mon Mar 17 2003 Erlend Midttun <erlendbm@trustix.com> 0.9.6-13tr
- Added official patch against blinding attack.

* Thu Feb 20 2003 Erlend Midttun <erlendbm@trustix.com> 0.9.6-12tr
- Added s3_pkt patch from Engarde.

* Mon Aug  5 2002 Christian H. Toldnes <christht@trustix.com> 0.9.6-11tr
- Fixed openssl-CAN-2002-065N-asn1_lib.patch since it was not correct.

* Mon Jul 29 2002 Christian H. Toldnes <christht@trustix.com> 0.9.6-10tr
- Changed openssl-CAN-2002-065N-asn1_lib.patch to also address a buffer
  overflow problem in the ASN1 related part of the code (asn1_lib.c).

* Fri Jul 26 2002 Christian H. Toldnes <christht@trustix.com> 0.9.6-9tr
- Added security patch for CAN-2002-0656 and CAN-2002-0655 (Patch 15-29)

* Wed Jul 11 2001 Oystein Viggen <oysteivi@trustix.com>
- Patch a security hole in the prng

* Mon Jun 25 2001 Oystein Viggen <oysteivi@trustix.com>
- Split off a -support package to remove perl dependancy from main package

* Thu Jun  7 2001 Erlend Midttun <erlendbm@trustix.com>
- Added a few patches to fix a few issues with 0.9.6.  Would upgrade
  to 0.9.6a, but that seem to break a load of packages.  Patches are
  from Engarde, not sure where they got them.

* Wed Mar  7 2001 Alexander Reelsen <ar@trustix.com>
- Moved libssl.so files completely out of openssl-devel

* Fri Feb 9 2001 Olaf Trygve Berglihn <olafb@trustix.com>
- Added openssl-python - the python M2Crypto bindings.

* Wed Nov 22 2000 Erlend Midttun <erlendbm@trustix.com>
- Updated to 0.9.6

* Mon Sep 4 2000 Per Ivar Paulsen <perp@trustix.com>
- Fixed man bug. openssl.cnf path fix.

* Thu May 18 2000 Erlend Midttun <erlendbm@trustix.com>
- Updated to version 0.9.5a

* Thu Mar 02 2000 Lars Gaarden <larsg@trustix.com>
- moved openssl.cnf back to /etc/ssl

* Thu Feb  3 2000 Tore Olsen <toreo@trustix.com>
- updated to 0.9.4

* Thu Jun 3 1999 Greg LaPolla <glapolla@hotmail.com>
- Added shared lib copy stuff 
* Tue Jun 1 1999 Greg LaPolla <glapolla@hotmail.com>
- Created SPEC and patches specific to rh6  

